﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Net;
using System.Net.Http;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace ConsoleApp1
{
    class Program
    {
        // static string _url = "http://127.0.0.1:8035";
        static string _url = "http://test.mypc.com:8035";
        static string _url2 = "http://pc.mytest.com:8035";
        static string _url3 = "http://my.pc.com:8035";

        static int _count = 0;

        static void Main(string[] args)
        {
            System.Net.ServicePointManager.DefaultConnectionLimit = 1;

            // System.Net.ServicePointManager.MaxServicePoints = 1;

            Console.WriteLine("DefaultConnectionLimit: " + System.Net.ServicePointManager.DefaultConnectionLimit);
            Console.WriteLine("DefaultPersistentConnectionLimit: " + System.Net.ServicePointManager.DefaultPersistentConnectionLimit);
            Console.WriteLine("MaxServicePoints: " + System.Net.ServicePointManager.MaxServicePoints);
            Console.WriteLine("MaxServicePointIdleTime: " + System.Net.ServicePointManager.MaxServicePointIdleTime);

            Console.WriteLine(_url + ": FindServicePoint.ConnectionLimit: " + System.Net.ServicePointManager.FindServicePoint(new Uri(_url)).ConnectionLimit);
            //Console.WriteLine(_url2 + ": FindServicePoint.ConnectionLimit: " + System.Net.ServicePointManager.FindServicePoint(new Uri(_url2)).ConnectionLimit);
            //Console.WriteLine(_url3 + ": FindServicePoint.ConnectionLimit: " + System.Net.ServicePointManager.FindServicePoint(new Uri(_url3)).ConnectionLimit);

            Console.WriteLine();
            Console.WriteLine();
            Console.WriteLine();

            Console.WriteLine("Default MaxConnectionsPerServer: " + new HttpClientHandler().MaxConnectionsPerServer);

            ThreadPool.SetMinThreads(100, 100);

            int reqCount = 3;

            _hwr = HttpWebRequest.CreateHttp(_url);
            _hwr.ServicePoint.ConnectionLimit = 2;
            _hwr.Headers.Add("Delay", "5000");

            string[] urls = new string[] { _url }; //, _url2, _url3 };

            // System.Net.ServicePointManager.DefaultConnectionLimit = 1;
            for (int i = 0; i < reqCount; i++)
            {
                ThreadPool.QueueUserWorkItem(requestHttp, urls[i % urls.Length]);
            }

            Console.ReadLine();

            // ThreadPool.QueueUserWorkItem(showInfo, null);
            // Console.ReadLine();
        }

        private static void requestHttp(object state)
        {
            requestHttpAsync(state).GetAwaiter().GetResult();
        }

        static HttpClient _httpClient = new HttpClient(new HttpClientHandler { MaxConnectionsPerServer = 2 });
        // static HttpClient _httpClient = new HttpClient();


        static HttpWebRequest _hwr;

        private static async Task requestHttpAsync(object state)
        {
            string url = state as string;
            int idx = Interlocked.Increment(ref _count);
            Thread.CurrentThread.Name = string.Format("request #{0}", idx);

            // HttpWebRequest req = _hwr;
            //HttpWebRequest req = HttpWebRequest.CreateHttp(url);
            //{
            //    //req.Headers.Add("Delay", "5000");
            //    //req.ServicePoint.Expect100Continue = false;

            //    Console.WriteLine(DateTime.Now + " Request: " + idx + " - Begin");
            //    HttpWebResponse resp = req.GetResponse() as HttpWebResponse;
            //    Console.WriteLine(DateTime.Now + " Request: " + idx + " - End");

            //    using (StreamReader sr = new StreamReader(resp.GetResponseStream()))
            //    {
            //        string txt = sr.ReadToEnd();
            //        // Console.WriteLine(txt);
            //    }

            //    // ShowProperties(req.ServicePoint);
            //}

            // using (HttpClient httpClient = new HttpClient(new HttpClientHandler { MaxConnectionsPerServer = 2 }))
            {
                try
                {
                    HttpRequestMessage req = new HttpRequestMessage(HttpMethod.Get, url);
                    req.Headers.Add("Delay", "5000");
                    HttpResponseMessage resp = await _httpClient.SendAsync(req);
                    string result = await resp.Content.ReadAsStringAsync();
                    // string result = await _httpClient.GetStringAsync(url);
                    Console.WriteLine("Ended");
                }
                catch { }
            }
        }

        //private static void showInfo(object state)
        //{
        //    string old = null;

        //    while (true)
        //    {
        //        ServicePoint svc = System.Net.ServicePointManager.FindServicePoint(new Uri(_url));

        //        string msg = svc.GetHashCode() + ": CurrentConnections = " + svc.CurrentConnections;
        //        if (old == msg)
        //        {
        //            Console.Write(".");
        //        }
        //        else
        //        {
        //            old = msg;
        //            Console.WriteLine(DateTime.Now + ": " + msg);
        //        }
        //        Thread.Sleep(1000);
        //    } 
        //}

        private static void ShowProperties(ServicePoint sp)
        {
            StringBuilder sb = new StringBuilder();

            sb.AppendFormat("Done calling: " + sp.GetHashCode()).AppendLine();

            sb.AppendFormat("Address = {0} ", sp.Address.ToString()).AppendLine();
            sb.AppendFormat("IdleSince = " + sp.IdleSince.ToString()).AppendLine();
            sb.AppendFormat("MaxIdleTime = " + sp.MaxIdleTime).AppendLine();
            sb.AppendFormat("ConnectionName = " + sp.ConnectionName).AppendLine();
            sb.AppendFormat("ConnectionLimit = " + sp.ConnectionLimit).AppendLine();
            sb.AppendFormat("CurrentConnections = " + sp.CurrentConnections).AppendLine();

            Console.WriteLine(sb.ToString());
        }

    }
}
